## clazy 1.4

=== CMakeLists.txt ===
# This is the top-level CMakeLists.txt file for the Clazy project.
#
# To build the man page from POD, run 'make man' after CMake (assumes perl is available)
# To install the resulting man page, run 'make install'
# The man page is not available on Windows.
#

project(ClangLazy)

cmake_minimum_required(VERSION 3.3)
include(FeatureSummary)
include(GenerateExportHeader)
include("GNUInstallDirs")

# Version setup
set(CLAZY_VERSION_MAJOR "1")
set(CLAZY_VERSION_MINOR "4")
set(CLAZY_VERSION_PATCH "0")
set(CLAZY_VERSION "${CLAZY_VERSION_MAJOR}.${CLAZY_VERSION_MINOR}.${CLAZY_VERSION_PATCH}")
set(CLAZY_PRINT_VERSION "${CLAZY_VERSION_MAJOR}.${CLAZY_VERSION_MINOR}")

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_LIST_DIR}/cmake)
if (NOT CLAZY_BUILD_WITH_CLANG)
  find_package(Clang 3.9 MODULE REQUIRED)
endif()

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)

add_definitions(-D__STDC_LIMIT_MACROS -D__STDC_CONSTANT_MACROS)
add_definitions(-D_GNU_SOURCE -DHAVE_CLANG_CONFIG_H)

option(CLAZY_BUILD_UTILS_LIB "Enable this option to build a library so you can reuse clazy's utility functions" OFF)
option(CLAZY_AST_MATCHERS_CRASH_WORKAROUND "Disable AST Matchers if being built with clang. See bug #392223" ON)

if (CLAZY_AST_MATCHERS_CRASH_WORKAROUND AND "${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
    message("Enabling AST Matchers workaround. Consider building with gcc instead. See bug #392223.")
    add_definitions(-DCLAZY_DISABLE_AST_MATCHERS)
endif()

if(CLAZY_BUILD_UTILS_LIB)
  add_definitions(-DCLAZY_BUILD_UTILS_LIB)
endif()

if(NOT CLAZY_BUILD_WITH_CLANG AND MSVC AND NOT CLANG_LIBRARY_IMPORT)
  message(FATAL_ERROR "\nOn MSVC you need to pass -DCLANG_LIBRARY_IMPORT=C:/path/to/llvm-build/lib/clang.lib to cmake when building Clazy.\nAlso make sure you've built LLVM with -DLLVM_EXPORT_SYMBOLS_FOR_PLUGINS=ON")
endif()

if(MSVC)
  # disable trigger-happy warnings from Clang/LLVM headers
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4267 /wd4244 /wd4291 /wd4800 /wd4141 /wd4146 /wd4251")
elseif(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -fno-common -Woverloaded-virtual -Wcast-qual -fno-strict-aliasing -pedantic -Wno-long-long -Wall -W -Wno-unused-parameter -Wwrite-strings -fno-exceptions -fno-rtti")
endif()

set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -Wl,-flat_namespace -Wl,-undefined -Wl,suppress")
if(WIN32)
  add_definitions(-D_CRT_SECURE_NO_WARNINGS)
else()
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC")
endif()

# Look for std::regex support
message("Looking for std::regex support...")
try_run(RUN_RESULT COMPILE_RESULT ${CMAKE_BINARY_DIR} ${CMAKE_CURRENT_LIST_DIR}/.cmake_has_regex_test.cpp)

if(RUN_RESULT EQUAL 0)
  set(HAS_STD_REGEX TRUE)
else()
  set(HAS_STD_REGEX FALSE)
  add_definitions(-DNO_STD_REGEX)
  message("old-style-connect check is disabled due to missing std::regex support")
  message("Suppressions are disabled due to missing std::regex support")
endif()

include(ClazySources.cmake)

include_directories(${CMAKE_BINARY_DIR})
include_directories(${CLANG_INCLUDE_DIRS} ${CMAKE_CURRENT_LIST_DIR} ${CMAKE_CURRENT_LIST_DIR}/src)
link_directories("${LLVM_INSTALL_PREFIX}/lib" ${LLVM_LIBRARY_DIRS})

macro(link_to_llvm name is_standalone)
  foreach(clang_lib ${CLANG_LIBS})
    if(MSVC)
      get_filename_component(LIB_FILENAME ${clang_lib} NAME)
      if(LIB_FILENAME STREQUAL "clangFrontend.lib")
        # On MSVC we don't link against clangFrontend.lib, instead we link against clang.exe (via clang.lib)
        # Otherwise the clazy plugin would have it's own plugin registry and clang wouldn't see it.
        # This way clazy registers with clang.
        continue()
      endif()
    endif()

    target_link_libraries(${name} ${clang_lib})
  endforeach()

  foreach(llvm_lib ${LLVM_LIBS})
    if(NOT ${is_standalone} AND NOT APPLE AND NOT MINGW AND NOT MSVC)
        ## Don't link against LLVMSupport, causes: CommandLine Error: Option 'view-background' registered more than once!
        if (NOT llvm_lib MATCHES ".*LLVMSupport.*")
            target_link_libraries(${name} ${llvm_lib})
        endif()
    else()
        target_link_libraries(${name} ${llvm_lib})
    endif()
  endforeach()

  foreach(user_lib ${USER_LIBS})
    target_link_libraries(${name} ${user_lib})
  endforeach()

  foreach(llvm_system_lib ${LLVM_SYSTEM_LIBS})
    target_link_libraries(${name} ${llvm_system_lib})
  endforeach()

  if(WIN32)
    target_link_libraries(${name} version.lib)
  endif()
endmacro()

macro(add_clang_plugin name)
  set(srcs ${ARGN})

  add_library(${name} SHARED ${srcs})

  if(SYMBOL_FILE)
    set_target_properties(${name} PROPERTIES LINK_FlAGS "-exported_symbols_list ${SYMBOL_FILE}")
  endif()

  link_to_llvm(${name} FALSE)

  if(MSVC)
    target_link_libraries(${name} ${CLANG_LIBRARY_IMPORT}) # Link against clang.exe to share the plugin registry
  endif()

  if(CLAZY_BUILD_UTILS_LIB)
    target_link_libraries(${name} clazylib)
  endif()
endmacro()

if(CLAZY_BUILD_UTILS_LIB)
  # clazylib version
  set(clazylib_VERSION_MAJOR 0)
  set(clazylib_VERSION_MINOR 1)
  # Enable the full x.y.z version only for release versions
  set(clazylib_VERSION_PATCH 0)

  set(clazylib_VERSION ${clazylib_VERSION_MAJOR}.${clazylib_VERSION_MINOR})
  add_library(clazylib SHARED ${CLAZY_LIB_SRC})
  link_to_llvm(clazylib FALSE)
  generate_export_header(clazylib)
  set_target_properties(clazylib PROPERTIES VERSION ${clazylib_VERSION} SOVERSION ${clazylib_VERSION_MAJOR})
  install(TARGETS clazylib EXPORT LibClazyExport
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
  )
endif()

set(SYMBOL_FILE Lazy.exports)

if (NOT CLAZY_BUILD_WITH_CLANG)
  add_clang_plugin(ClangLazy ${CLAZY_PLUGIN_SRCS})
  set_target_properties(ClangLazy PROPERTIES
    LINKER_LANGUAGE CXX
    PREFIX ""
  )

  install(TARGETS ClangLazy
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
  )

  set(SHARE_INSTALL_DIR ${CMAKE_INSTALL_DATAROOTDIR} CACHE STRING "Share directory name")

  if(NOT WIN32)
    configure_file(${CMAKE_CURRENT_LIST_DIR}/clazy.cmake ${CMAKE_BINARY_DIR}/clazy @ONLY)
    install(FILES ${CMAKE_BINARY_DIR}/clazy DESTINATION bin PERMISSIONS OWNER_WRITE OWNER_EXECUTE OWNER_READ GROUP_EXECUTE GROUP_READ WORLD_READ WORLD_EXECUTE)
  else()
    install(FILES ${CMAKE_CURRENT_LIST_DIR}/clazy.bat DESTINATION bin PERMISSIONS OWNER_WRITE OWNER_EXECUTE OWNER_READ GROUP_EXECUTE GROUP_READ WORLD_READ WORLD_EXECUTE)
    if(MSVC)
      install(FILES ${CMAKE_CURRENT_LIST_DIR}/clazy-cl.bat DESTINATION bin PERMISSIONS OWNER_WRITE OWNER_EXECUTE OWNER_READ GROUP_EXECUTE GROUP_READ WORLD_READ WORLD_EXECUTE)
    endif()
  endif()

  # Install the explanation README's
  set(DOC_INSTALL_DIR ${SHARE_INSTALL_DIR}/doc/clazy)

  include(${CMAKE_CURRENT_LIST_DIR}/readmes.cmake)

  install(FILES ${README_LEVEL0_FILES} DESTINATION ${DOC_INSTALL_DIR}/level0)
  install(FILES ${README_LEVEL1_FILES} DESTINATION ${DOC_INSTALL_DIR}/level1)
  install(FILES ${README_LEVEL2_FILES} DESTINATION ${DOC_INSTALL_DIR}/level2)
  install(FILES ${README_LEVEL3_FILES} DESTINATION ${DOC_INSTALL_DIR}/level3)
  install(FILES ${README_manuallevel_FILES} DESTINATION ${DOC_INSTALL_DIR}/manuallevel)

  # Install more doc files
  install(FILES README.md COPYING-LGPL2.txt checks.json DESTINATION ${DOC_INSTALL_DIR})

  # Build docs
  set(MAN_INSTALL_DIR "${SHARE_INSTALL_DIR}/man/man1")
  add_subdirectory(docs)

  if(CLAZY_BUILD_UTILS_LIB)
    # Install public headers
    set(CLAZY_LIB_INCLUDES
      src/AccessSpecifierManager.h
      src/checkbase.h
      src/checkmanager.h
      src/clazy_export.h
      src/clazy_stl.h
      src/ContextUtils.h
      src/FixItUtils.h
      src/HierarchyUtils.h
      src/LoopUtils.h
      src/MacroUtils.h
      src/QtUtils.h
      src/SuppressionManager.h
      src/StmtBodyRange.h
      src/StringUtils.h
      src/TemplateUtils.h
      src/TypeUtils.h
      src/Utils.h
      src/ClazyContext.h
      )
    install(FILES ${CLAZY_LIB_INCLUDES} DESTINATION include/clazy)
  endif()

  # rpath
  set(CMAKE_SKIP_BUILD_RPATH FALSE)
  set(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
  set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}")
  set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
  list(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}" isSystemDir)
  if("${isSystemDir}" STREQUAL "-1")
    set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}")
  endif("${isSystemDir}" STREQUAL "-1")

  # Build clazy-standalone
  add_executable(clazy-standalone ${CLAZY_STANDALONE_SRCS})

  if(MSVC)
    # On MSVC clang-standalone crashes with a meaningless backtrace if linked to ClangLazy.dll
    target_link_libraries(clazy-standalone clangFrontend)
  else()
    target_link_libraries(clazy-standalone ClangLazy)
  endif()

  link_to_llvm(clazy-standalone TRUE)

  install(TARGETS clazy-standalone DESTINATION bin PERMISSIONS OWNER_WRITE OWNER_EXECUTE OWNER_READ GROUP_EXECUTE GROUP_READ WORLD_READ WORLD_EXECUTE)

  set(CPACK_PACKAGE_VERSION_MAJOR ${CLAZY_VERSION_MAJOR})
  set(CPACK_PACKAGE_VERSION_MINOR ${CLAZY_VERSION_MINOR})
  set(CPACK_PACKAGE_VERSION_PATCH ${CLAZY_VERSION_PATCH})
  include(CPack)
else()
  set(LLVM_LINK_COMPONENTS
    Support
    )
  add_clang_library(clazyPlugin
    ${CLAZY_PLUGIN_SRCS}

    LINK_LIBS
    clangFrontend
    clangDriver
    clangCodeGen
    clangSema
    clangAnalysis
    clangRewriteFrontend
    clangRewrite
    clangAST
    clangASTMatchers
    clangParse
    clangLex
    clangBasic
    clangARCMigrate
    clangEdit
    clangFrontendTool
    clangRewrite
    clangSerialization
    clangTooling
    clangStaticAnalyzerCheckers
    clangStaticAnalyzerCore
    clangStaticAnalyzerFrontend
    )
  add_executable(clazy-standalone ${CLAZY_STANDALONE_SRCS})

  target_link_libraries(clazy-standalone clazyPlugin)

  install(TARGETS clazy-standalone DESTINATION bin PERMISSIONS OWNER_WRITE OWNER_EXECUTE OWNER_READ GROUP_EXECUTE GROUP_READ WORLD_READ WORLD_EXECUTE)
endif()

=== debian/changelog ===
clazy (1.4-4ubuntu2) disco; urgency=medium

  * Explicitly build using clang 7.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 30 Jan 2019 10:02:25 +0100

clazy (1.4-4) unstable; urgency=medium

  [ Lisandro Damián Nicanor Pérez Meyer ]
  * Fix typo in debian/rules.

  [ Pino Toscano ]
  * Ensure that clazy uses, and requires the same Clang used at build time:
    (Closes: #915390)
    - add a way to enforce a specific clang++ executable; patch
      select-clangpp.diff
    - specify the clang++ executable of the default Clang version
    - depend on the clang package providing the selected clang++ executable

 -- Pino Toscano <pino@debian.org>  Tue, 18 Dec 2018 21:58:07 +0100

clazy (1.4-3) unstable; urgency=medium

  * Backport upstream commit 9713a15f65424f06e45c78fc1bf1c2d2b27f4e36 to use 64
    as the limit in inefficient-qlist (fixing the test suite on 32bit Linux
    architectures); patch
    upstream_inefficient-qlist-Use-64-as-the-limit-instead-of-siz.patch.
  * Make sure to link with atomic on armel, both when building, and when
    linking the tests.

 -- Pino Toscano <pino@debian.org>  Sun, 02 Dec 2018 10:36:29 +0100

clazy (1.4-2) unstable; urgency=medium

  * Backport upstream commit 8ad500134416b960b3c28146e7245b7403f4c851 to
    properly install the clazy wrapper script as executable; patch
    upstream_Fix-installation-of-clazy-wrapper-scripts.patch.
  * Fix the execution of the test suite:
    - make the clazy wrapper script executable in the build directory, so it
      can be run
    - add the top-level build directory to $PATH, so that the clazy script
      is found
  * Fix Vcs-Git field to its non-redirecting version.
  * 'run-tests' autopkgtest: query clang/clang++ for their basic facts (like
    include/library paths, etc), so it is easier to debug test failures.

 -- Pino Toscano <pino@debian.org>  Tue, 27 Nov 2018 07:27:10 +0100

clazy (1.4-1) unstable; urgency=medium

  [ Scarlett Clark ]
  [ Pino Toscano ]
  * Initial release (Closes: #886883)

 -- Scarlett Clark <sgclark@kde.org>  Sun, 04 Nov 2018 22:03:44 +0100

=== debian/control ===
Source: clazy
Section: devel
Priority: optional
Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Scarlett Clark <sgclark@kde.org>,
 Pino Toscano <pino@debian.org>
Build-Depends: chrpath,
               clang-7 (>= 1:3.9~),
               cmake (>= 3.3~),
               debhelper (>= 11~),
               libclang-7-dev (>= 1:3.9~),
               llvm-7-dev (>= 1:3.9~),
               python2,
               qtbase5-dev,
Standards-Version: 4.2.1
Homepage: https://www.kdab.com/clazy-video/
Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/clazy.git
Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/clazy

Package: clazy
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, ${clazy:clang}
Description: Clang plugin for additional warnings
 Clazy is a Clang plugin which extends the compiler with over
 50 warnings related to Qt best practices ranging from unneeded
 memory allocations to API misuse. It’s an opensource project
 spawned by KDAB’s R&D efforts for better C++ tooling.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# LLVM 6.0 headers produce lots of class-memaccess warnings
export DEB_CXXFLAGS_MAINT_APPEND = -Wno-class-memaccess

archs_that_need_atomic = armel
ifeq ($(DEB_HOST_ARCH),$(findstring $(DEB_HOST_ARCH), $(archs_that_need_atomic)))
export DEB_LDFLAGS_MAINT_APPEND = -latomic
endif

# keep the "++" at the end, to make sure the tool used is the C++ frontend
CLANGPP=$(shell realpath $$(which clang++-7))++-7
CLANGPP=/usr/bin/clang++-7
LLVM_CONFIG=/usr/bin/llvm-config-7

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DCLANGPP_EXECUTABLE="$(CLANGPP)" -DLLVM_CONFIG_EXECUTABLE=$(LLVM_CONFIG)

override_dh_auto_install:
	dh_auto_install
	# drop RPATH pointing to the private libdir of LLVM libraries,
	# i.e. /usr/lib/llvm-$VERSION/lib
	chrpath -d $(CURDIR)/debian/clazy/usr/bin/clazy-standalone $(CURDIR)/debian/clazy/usr/lib/*/*.so
	# drop extra license file
	rm $(CURDIR)/debian/clazy/usr/share/doc/clazy/COPYING-LGPL2.txt

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	chmod +x $(CURDIR)/obj-$(DEB_HOST_GNU_TYPE)/clazy
	cd tests && env PATH=$(CURDIR)/obj-$(DEB_HOST_GNU_TYPE):$(CURDIR)/obj-$(DEB_HOST_GNU_TYPE)/bin:$(PATH) LD_LIBRARY_PATH=$(CURDIR)/obj-$(DEB_HOST_GNU_TYPE)/lib DEB_HOST_ARCH=$(DEB_HOST_ARCH) CLANGXX=$(CLANGPP) ./run_tests.py --verbose
endif

override_dh_compress:
	# do not compress documentation markdown & JSON files
	dh_compress -X.md -X.json

override_dh_gencontrol:
	dh_gencontrol -- -V'clazy:clang=$(shell dpkg -S "$(CLANGPP)" | cut -d: -f1)'

=== debian/tests/control ===
Tests: run-tests
Depends: @, clang-7, python2, qtbase5-dev
Restrictions: rw-build-tree, allow-stderr

## clazy 1.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
 # The man page is not available on Windows.
 #
 
-project(ClangLazy)
+project(clazy)
 
 cmake_minimum_required(VERSION 3.3)
 include(FeatureSummary)
@@ -14,7 +14,7 @@
 
 # Version setup
 set(CLAZY_VERSION_MAJOR "1")
-set(CLAZY_VERSION_MINOR "4")
+set(CLAZY_VERSION_MINOR "5")
 set(CLAZY_VERSION_PATCH "0")
 set(CLAZY_VERSION "${CLAZY_VERSION_MAJOR}.${CLAZY_VERSION_MINOR}.${CLAZY_VERSION_PATCH}")
 set(CLAZY_PRINT_VERSION "${CLAZY_VERSION_MAJOR}.${CLAZY_VERSION_MINOR}")
@@ -31,16 +31,12 @@
 add_definitions(-D__STDC_LIMIT_MACROS -D__STDC_CONSTANT_MACROS)
 add_definitions(-D_GNU_SOURCE -DHAVE_CLANG_CONFIG_H)
 
-option(CLAZY_BUILD_UTILS_LIB "Enable this option to build a library so you can reuse clazy's utility functions" OFF)
 option(CLAZY_AST_MATCHERS_CRASH_WORKAROUND "Disable AST Matchers if being built with clang. See bug #392223" ON)
+option(LINK_CLAZY_TO_LLVM "Links the clazy plugin to LLVM. Switch to OFF if your clang binary has all symbols already. Might need to be OFF if your LLVM is static." ON)
 
 if (CLAZY_AST_MATCHERS_CRASH_WORKAROUND AND "${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
     message("Enabling AST Matchers workaround. Consider building with gcc instead. See bug #392223.")
     add_definitions(-DCLAZY_DISABLE_AST_MATCHERS)
-endif()
-
-if(CLAZY_BUILD_UTILS_LIB)
-  add_definitions(-DCLAZY_BUILD_UTILS_LIB)
 endif()
 
 if(NOT CLAZY_BUILD_WITH_CLANG AND MSVC AND NOT CLANG_LIBRARY_IMPORT)
@@ -128,60 +124,42 @@
     set_target_properties(${name} PROPERTIES LINK_FlAGS "-exported_symbols_list ${SYMBOL_FILE}")
   endif()
 
-  link_to_llvm(${name} FALSE)
+  if (LINK_CLAZY_TO_LLVM)
+    link_to_llvm(${name} FALSE)
+  endif()
 
   if(MSVC)
     target_link_libraries(${name} ${CLANG_LIBRARY_IMPORT}) # Link against clang.exe to share the plugin registry
   endif()
 
-  if(CLAZY_BUILD_UTILS_LIB)
-    target_link_libraries(${name} clazylib)
-  endif()
 endmacro()
 
-if(CLAZY_BUILD_UTILS_LIB)
-  # clazylib version
-  set(clazylib_VERSION_MAJOR 0)
-  set(clazylib_VERSION_MINOR 1)
-  # Enable the full x.y.z version only for release versions
-  set(clazylib_VERSION_PATCH 0)
-
-  set(clazylib_VERSION ${clazylib_VERSION_MAJOR}.${clazylib_VERSION_MINOR})
-  add_library(clazylib SHARED ${CLAZY_LIB_SRC})
-  link_to_llvm(clazylib FALSE)
-  generate_export_header(clazylib)
-  set_target_properties(clazylib PROPERTIES VERSION ${clazylib_VERSION} SOVERSION ${clazylib_VERSION_MAJOR})
-  install(TARGETS clazylib EXPORT LibClazyExport
+set(SYMBOL_FILE Lazy.exports)
+
+if (NOT CLAZY_BUILD_WITH_CLANG)
+  add_clang_plugin(ClazyPlugin ${CLAZY_PLUGIN_SRCS})
+  set_target_properties(ClazyPlugin PROPERTIES
+    LINKER_LANGUAGE CXX
+    PREFIX ""
+  )
+
+  install(TARGETS ClazyPlugin
     RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
     LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
     ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
   )
-endif()
-
-set(SYMBOL_FILE Lazy.exports)
-
-if (NOT CLAZY_BUILD_WITH_CLANG)
-  add_clang_plugin(ClangLazy ${CLAZY_PLUGIN_SRCS})
-  set_target_properties(ClangLazy PROPERTIES
-    LINKER_LANGUAGE CXX
-    PREFIX ""
-  )
-
-  install(TARGETS ClangLazy
-    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
-    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
-    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
-  )
 
   set(SHARE_INSTALL_DIR ${CMAKE_INSTALL_DATAROOTDIR} CACHE STRING "Share directory name")
 
   if(NOT WIN32)
+    file(RELATIVE_PATH BIN_RELATIVE_LIBDIR "${CMAKE_INSTALL_FULL_BINDIR}" "${CMAKE_INSTALL_FULL_LIBDIR}")
+    file(RELATIVE_PATH BIN_RELATIVE_SHAREDIR "${CMAKE_INSTALL_FULL_BINDIR}" "${CMAKE_INSTALL_FULL_DATAROOTDIR}")
     configure_file(${CMAKE_CURRENT_LIST_DIR}/clazy.cmake ${CMAKE_BINARY_DIR}/clazy @ONLY)
-    install(FILES ${CMAKE_BINARY_DIR}/clazy DESTINATION bin PERMISSIONS OWNER_WRITE OWNER_EXECUTE OWNER_READ GROUP_EXECUTE GROUP_READ WORLD_READ WORLD_EXECUTE)
+    install(PROGRAMS ${CMAKE_BINARY_DIR}/clazy DESTINATION bin)
   else()
-    install(FILES ${CMAKE_CURRENT_LIST_DIR}/clazy.bat DESTINATION bin PERMISSIONS OWNER_WRITE OWNER_EXECUTE OWNER_READ GROUP_EXECUTE GROUP_READ WORLD_READ WORLD_EXECUTE)
+    install(PROGRAMS ${CMAKE_CURRENT_LIST_DIR}/clazy.bat DESTINATION bin)
     if(MSVC)
-      install(FILES ${CMAKE_CURRENT_LIST_DIR}/clazy-cl.bat DESTINATION bin PERMISSIONS OWNER_WRITE OWNER_EXECUTE OWNER_READ GROUP_EXECUTE GROUP_READ WORLD_READ WORLD_EXECUTE)
+      install(PROGRAMS ${CMAKE_CURRENT_LIST_DIR}/clazy-cl.bat DESTINATION bin)
     endif()
   endif()
 
@@ -202,31 +180,6 @@
   # Build docs
   set(MAN_INSTALL_DIR "${SHARE_INSTALL_DIR}/man/man1")
   add_subdirectory(docs)
-
-  if(CLAZY_BUILD_UTILS_LIB)
-    # Install public headers
-    set(CLAZY_LIB_INCLUDES
-      src/AccessSpecifierManager.h
-      src/checkbase.h
-      src/checkmanager.h
-      src/clazy_export.h
-      src/clazy_stl.h
-      src/ContextUtils.h
-      src/FixItUtils.h
-      src/HierarchyUtils.h
-      src/LoopUtils.h
-      src/MacroUtils.h
-      src/QtUtils.h
-      src/SuppressionManager.h
-      src/StmtBodyRange.h
-      src/StringUtils.h
-      src/TemplateUtils.h
-      src/TypeUtils.h
-      src/Utils.h
-      src/ClazyContext.h
-      )
-    install(FILES ${CLAZY_LIB_INCLUDES} DESTINATION include/clazy)
-  endif()
 
   # rpath
   set(CMAKE_SKIP_BUILD_RPATH FALSE)
@@ -242,10 +195,10 @@
   add_executable(clazy-standalone ${CLAZY_STANDALONE_SRCS})
 
   if(MSVC)
-    # On MSVC clang-standalone crashes with a meaningless backtrace if linked to ClangLazy.dll
+    # On MSVC clang-standalone crashes with a meaningless backtrace if linked to ClazyPlugin.dll
     target_link_libraries(clazy-standalone clangFrontend)
   else()
-    target_link_libraries(clazy-standalone ClangLazy)
+    target_link_libraries(clazy-standalone ClazyPlugin)
   endif()
 
   link_to_llvm(clazy-standalone TRUE)

=== debian/changelog ===
clazy (1.5-1ubuntu4) eoan; urgency=medium

  * Build with llvm/clang 8 (test errors with 9)..

 -- Matthias Klose <doko@ubuntu.com>  Thu, 22 Aug 2019 14:13:47 +0200

clazy (1.5-1ubuntu3) eoan; urgency=medium

  * Rebuild against new qt 5.12.2.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 05 Jun 2019 10:35:21 +0200

clazy (1.5-1ubuntu2) disco; urgency=medium

  * Drop Ubuntu delta. Allows build and tests to run with llvm/clang 8.

 -- Rik Mills <rikmills@kubuntu.org>  Tue, 19 Mar 2019 16:05:26 +0000

clazy (1.5-1ubuntu1) disco; urgency=medium

  * Merge with Debian unstable. Remaining changes:
    - Explicitly build using clang 7.

 -- Rik Mills <rikmills@kubuntu.org>  Thu, 21 Feb 2019 08:23:21 +0000

clazy (1.5-1) unstable; urgency=medium

  * New upstream release.
  * Update the patches:
    - upstream_Fix-clazy-list-not-listing-the-correct-doc-directory.patch:
      drop, backported from upstream
    - upstream_docs-add-empty-line-between-encoding-and-head1-NAME.patch: drop,
      backported from upstream
    - upstream_Fix-installation-of-clazy-wrapper-scripts.patch: drop,
      backported from upstream
    - upstream_inefficient-qlist-Use-64-as-the-limit-instead-of-siz.patch:
      drop, backported from upstream
    - debian-tests-link-atomic.diff: refresh
    - select-clangpp.diff: update to the new upstream version, and simplify
  * Update copyright.
  * Add qtdeclarative5-dev as build dependency, and as dependency for the
   'run-tests' autopkgtest, as it is needed by the test suite.
  * Update lintian overrides.
  + Bump Standards-Version to 4.3.0, no changes required.

 -- Pino Toscano <pino@debian.org>  Wed, 06 Feb 2019 22:26:46 +0100

=== debian/control ===
--- 
+++ 
@@ -5,14 +5,15 @@
 Uploaders: Scarlett Clark <sgclark@kde.org>,
  Pino Toscano <pino@debian.org>
 Build-Depends: chrpath,
-               clang-7 (>= 1:3.9~),
+               clang-8 (>= 1:3.9~),
                cmake (>= 3.3~),
                debhelper (>= 11~),
-               libclang-7-dev (>= 1:3.9~),
-               llvm-7-dev (>= 1:3.9~),
+               libclang-8-dev (>= 1:3.9~),
+               llvm-8-dev (>= 1:3.9~),
                python2,
                qtbase5-dev,
-Standards-Version: 4.2.1
+               qtdeclarative5-dev,
+Standards-Version: 4.3.0
 Homepage: https://www.kdab.com/clazy-video/
 Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/clazy.git
 Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/clazy

=== debian/rules ===
--- 
+++ 
@@ -13,9 +13,9 @@
 endif
 
 # keep the "++" at the end, to make sure the tool used is the C++ frontend
-CLANGPP=$(shell realpath $$(which clang++-7))++-7
-CLANGPP=/usr/bin/clang++-7
-LLVM_CONFIG=/usr/bin/llvm-config-7
+CLANGPP=$(shell realpath $$(which clang++-8))++-8
+CLANGPP=/usr/bin/clang++-8
+LLVM_CONFIG=/usr/bin/llvm-config-8
 
 %:
 	dh $@

=== debian/tests/control ===
Tests: run-tests
Depends: @, clang-8, python2, qtbase5-dev, qtdeclarative5-dev
Restrictions: rw-build-tree, allow-stderr

## clazy 1.6

=== CMakeLists.txt ===
--- 
+++ 
@@ -7,21 +7,26 @@
 
 project(clazy)
 
-cmake_minimum_required(VERSION 3.3)
+cmake_minimum_required(VERSION 3.7)
+
+if (${CMAKE_VERSION} VERSION_GREATER_EQUAL "3.12.0")
+    cmake_policy(SET CMP0074 NEW)
+endif()
+
 include(FeatureSummary)
 include(GenerateExportHeader)
 include("GNUInstallDirs")
 
 # Version setup
 set(CLAZY_VERSION_MAJOR "1")
-set(CLAZY_VERSION_MINOR "5")
+set(CLAZY_VERSION_MINOR "6")
 set(CLAZY_VERSION_PATCH "0")
 set(CLAZY_VERSION "${CLAZY_VERSION_MAJOR}.${CLAZY_VERSION_MINOR}.${CLAZY_VERSION_PATCH}")
 set(CLAZY_PRINT_VERSION "${CLAZY_VERSION_MAJOR}.${CLAZY_VERSION_MINOR}")
 
 set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_LIST_DIR}/cmake)
 if (NOT CLAZY_BUILD_WITH_CLANG)
-  find_package(Clang 3.9 MODULE REQUIRED)
+  find_package(Clang 5.0 MODULE REQUIRED)
 endif()
 
 set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
@@ -75,6 +80,12 @@
 include_directories(${CMAKE_BINARY_DIR})
 include_directories(${CLANG_INCLUDE_DIRS} ${CMAKE_CURRENT_LIST_DIR} ${CMAKE_CURRENT_LIST_DIR}/src)
 link_directories("${LLVM_INSTALL_PREFIX}/lib" ${LLVM_LIBRARY_DIRS})
+
+if (${LLVM_VERSION} VERSION_GREATER_EQUAL "9.0.0")
+    set(clang_tooling_refactoring_lib clangToolingRefactoring)
+else()
+    set(clang_tooling_refactoring_lib clangToolingRefactor)
+endif()
 
 macro(link_to_llvm name is_standalone)
   foreach(clang_lib ${CLANG_LIBS})
@@ -113,6 +124,9 @@
   if(WIN32)
     target_link_libraries(${name} version.lib)
   endif()
+    target_link_libraries(${name} clangTooling)
+    target_link_libraries(${name} clangToolingCore)
+    target_link_libraries(${name} ${clang_tooling_refactoring_lib})
 endmacro()
 
 macro(add_clang_plugin name)
@@ -137,7 +151,8 @@
 set(SYMBOL_FILE Lazy.exports)
 
 if (NOT CLAZY_BUILD_WITH_CLANG)
-  add_clang_plugin(ClazyPlugin ${CLAZY_PLUGIN_SRCS})
+  set(CLAZY_MINI_AST_DUMPER_SRCS src/MiniAstDumper.cpp)
+  add_clang_plugin(ClazyPlugin ${CLAZY_PLUGIN_SRCS} ${CLAZY_MINI_AST_DUMPER_SRCS})
   set_target_properties(ClazyPlugin PROPERTIES
     LINKER_LANGUAGE CXX
     PREFIX ""
@@ -171,7 +186,6 @@
   install(FILES ${README_LEVEL0_FILES} DESTINATION ${DOC_INSTALL_DIR}/level0)
   install(FILES ${README_LEVEL1_FILES} DESTINATION ${DOC_INSTALL_DIR}/level1)
   install(FILES ${README_LEVEL2_FILES} DESTINATION ${DOC_INSTALL_DIR}/level2)
-  install(FILES ${README_LEVEL3_FILES} DESTINATION ${DOC_INSTALL_DIR}/level3)
   install(FILES ${README_manuallevel_FILES} DESTINATION ${DOC_INSTALL_DIR}/manuallevel)
 
   # Install more doc files
@@ -217,6 +231,9 @@
     ${CLAZY_PLUGIN_SRCS}
 
     LINK_LIBS
+    clangToolingCore
+    clangToolingInclusions
+    ${clang_tooling_refactoring_lib}
     clangFrontend
     clangDriver
     clangCodeGen
@@ -245,3 +262,36 @@
 
   install(TARGETS clazy-standalone DESTINATION bin PERMISSIONS OWNER_WRITE OWNER_EXECUTE OWNER_READ GROUP_EXECUTE GROUP_READ WORLD_READ WORLD_EXECUTE)
 endif()
+
+function(to_raw_string_literal input_string output_string)
+    if (MSVC)
+        # Work around "C2026: string too big, trailing characters truncated"
+        #   https://docs.microsoft.com/en-us/cpp/error-messages/compiler-errors-1/compiler-error-c2026?view=vs-2019
+        # The limit is 16380 single-byte characters, so split up the string as
+        # suggested on the site.
+        set(str ${input_string})
+        set(chunk_size 1000)
+        set(result "\n")
+        string(LENGTH ${str} str_size)
+        while (${str_size} GREATER ${chunk_size})
+            string(SUBSTRING ${str} 0 ${chunk_size} chunk)
+            string(SUBSTRING ${str} ${chunk_size} -1 str)
+            set(chunk "R\"meta(${chunk})meta\"\n")
+            string(APPEND result ${chunk})
+            string(LENGTH ${str} str_size)
+        endwhile()
+        if (str_size GREATER 0)
+            string(APPEND result "R\"meta(${str})meta\"\n")
+        endif()
+        set(${output_string} ${result} PARENT_SCOPE)
+    else()
+        set(result "\nR\"meta(${input_string})meta\"\n")
+        set(${output_string} ${result} PARENT_SCOPE)
+    endif()
+endfunction()
+
+file(READ checks.json SUPPORTED_CHECKS_JSON_STR)
+to_raw_string_literal(${SUPPORTED_CHECKS_JSON_STR} SUPPORTED_CHECKS_JSON_STR)
+configure_file(checks.json.h.in checks.json.h)
+
+install(FILES org.kde.clazy.metainfo.xml DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/metainfo)

=== docs/man/CMakeLists.txt ===
if(UNIX)
  find_program(POD2MAN_EXECUTABLE pod2man)
  set_package_properties(pod2man PROPERTIES
    TYPE RECOMMENDED
    DESCRIPTION "Man page generator"
    PURPOSE "Generate clazy man pages."
  )

  if(POD2MAN_EXECUTABLE)
    add_custom_command(
      OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/clazy.1
      COMMAND ${POD2MAN_EXECUTABLE} -c "KDAB" -r "\"${CLAZY_VERSION}\"" -s 1 ${CMAKE_CURRENT_SOURCE_DIR}/clazy.pod ${CMAKE_CURRENT_BINARY_DIR}/clazy.1
      DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/clazy.pod
    )
    add_custom_target(man ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/clazy.1)

    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/clazy.1 DESTINATION ${MAN_INSTALL_DIR})
  endif()
endif()

=== debian/changelog ===
clazy (1.6-2ubuntu5) focal; urgency=medium

  * Explicitly build using LLVM 9.
  * Add /usr/lib/llvm-9/bin to PATH for running the autopkg tests.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 11 Mar 2020 08:58:12 +0100

clazy (1.6-2ubuntu3) focal; urgency=medium

  * Drop all the delta, it was concerning i386 sadness, but i386 is not the
    case anymore on focal.
  * No change rebuild against newer qt

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 12 Dec 2019 11:07:27 +0100

clazy (1.6-2) unstable; urgency=medium

  * Update copyright.
  * Bump the debhelper compatibility to 12:
    - switch the debhelper build dependency to debhelper-compat 12
    - remove debian/compat
  * Exclude the inefficient-qlist check on i386, as it currectly does not
    match the baseline (although it correctly detects the issue).

 -- Pino Toscano <pino@debian.org>  Sun, 20 Oct 2019 00:14:09 +0200

clazy (1.6-1) unstable; urgency=medium

  [ Lisandro Damián Nicanor Pérez Meyer ]
  * Switch python2 to python3 as build requirement. (Closes: #936308)

  [ Pino Toscano ]
  * New upstream release.
  * Update the patches:
    - debian-tests-link-atomic.diff: refresh
    - select-clangpp.diff: refresh
  * Update the build dependencies according to the upstream build system:
    - bump cmake to 3.7
    - bump clang, libclang-dev, and llvm-dev to 5.0
    - add clang-tools
  * Add the configuration for the CI on salsa.
  * Update the dependencies for the 'run-tests' autopkgtest:
    - replace python2 with python3 (see #936308)
    - add clang-tools
  * Bump Standards-Version to 4.4.1, no changes required.
  * Get the real clang++ compiler bypassing ccache.
  * Make sure to link with atomic (on architectures that need it) even if the
    compiler links in as-needed mode by default. (Closes: #939687)
  * Disable ccache when running the test suite, as clazy is documented to not
    work with it.

 -- Pino Toscano <pino@debian.org>  Fri, 18 Oct 2019 15:26:39 +0200

=== debian/control ===
--- 
+++ 
@@ -5,15 +5,16 @@
 Uploaders: Scarlett Clark <sgclark@kde.org>,
  Pino Toscano <pino@debian.org>
 Build-Depends: chrpath,
-               clang-8 (>= 1:3.9~),
-               cmake (>= 3.3~),
-               debhelper (>= 11~),
-               libclang-8-dev (>= 1:3.9~),
-               llvm-8-dev (>= 1:3.9~),
-               python2,
+               clang-9 (>= 1:5.0~),
+               clang-tools-9 (>= 1:5.0~),
+               cmake (>= 3.7~),
+               debhelper-compat (= 12),
+               libclang-9-dev (>= 1:5.0~),
+               llvm-9-dev (>= 1:5.0~),
+               python3,
                qtbase5-dev,
                qtdeclarative5-dev,
-Standards-Version: 4.3.0
+Standards-Version: 4.4.1
 Homepage: https://www.kdab.com/clazy-video/
 Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/clazy.git
 Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/clazy

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

PATH := /usr/lib/llvm-9/bin:$(PATH)
export PATH

# LLVM 6.0 headers produce lots of class-memaccess warnings
export DEB_CXXFLAGS_MAINT_APPEND = -Wno-class-memaccess

archs_that_need_atomic = armel
ifeq ($(DEB_HOST_ARCH),$(findstring $(DEB_HOST_ARCH), $(archs_that_need_atomic)))
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--no-as-needed -latomic -Wl,--as-needed
endif

# wrong size reported, although the test correctly identifies the issue
# https://bugs.kde.org/show_bug.cgi?id=413169
ifeq ($(DEB_HOST_ARCH),i386)
RUN_TESTS_ARGS += --exclude inefficient-qlist
endif

# keep the "++" at the end, to make sure the tool used is the C++ frontend
CLANGPP=$(shell realpath $$(env PATH=$$(echo "$$PATH" | sed -r -e 's|/usr/lib/ccache/?:||') which clang++))++

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DCLANGPP_EXECUTABLE="$(CLANGPP)"

override_dh_auto_install:
	dh_auto_install
	# drop RPATH pointing to the private libdir of LLVM libraries,
	# i.e. /usr/lib/llvm-$VERSION/lib
	chrpath -d $(CURDIR)/debian/clazy/usr/bin/clazy-standalone $(CURDIR)/debian/clazy/usr/lib/*/*.so
	# drop extra license file
	rm $(CURDIR)/debian/clazy/usr/share/doc/clazy/COPYING-LGPL2.txt

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	chmod +x $(CURDIR)/obj-$(DEB_HOST_GNU_TYPE)/clazy
	cd tests && env PATH=$(CURDIR)/obj-$(DEB_HOST_GNU_TYPE):$(CURDIR)/obj-$(DEB_HOST_GNU_TYPE)/bin:$(PATH) LD_LIBRARY_PATH=$(CURDIR)/obj-$(DEB_HOST_GNU_TYPE)/lib DEB_HOST_ARCH=$(DEB_HOST_ARCH) CCACHE_DISABLE=1 ./run_tests.py --verbose $(RUN_TESTS_ARGS)
endif

override_dh_compress:
	# do not compress documentation markdown & JSON files
	dh_compress -X.md -X.json

override_dh_gencontrol:
	dh_gencontrol -- -V'clazy:clang=$(shell dpkg -S "$(CLANGPP)" | cut -d: -f1)'

=== debian/tests/control ===
Tests: run-tests
Depends: @, clang-9, clang-tools-9, python3, qtbase5-dev, qtdeclarative5-dev
Restrictions: rw-build-tree, allow-stderr

## clazy 1.7

=== CMakeLists.txt ===
--- 
+++ 
@@ -19,7 +19,7 @@
 
 # Version setup
 set(CLAZY_VERSION_MAJOR "1")
-set(CLAZY_VERSION_MINOR "6")
+set(CLAZY_VERSION_MINOR "7")
 set(CLAZY_VERSION_PATCH "0")
 set(CLAZY_VERSION "${CLAZY_VERSION_MAJOR}.${CLAZY_VERSION_MINOR}.${CLAZY_VERSION_PATCH}")
 set(CLAZY_PRINT_VERSION "${CLAZY_VERSION_MAJOR}.${CLAZY_VERSION_MINOR}")
@@ -38,6 +38,7 @@
 
 option(CLAZY_AST_MATCHERS_CRASH_WORKAROUND "Disable AST Matchers if being built with clang. See bug #392223" ON)
 option(LINK_CLAZY_TO_LLVM "Links the clazy plugin to LLVM. Switch to OFF if your clang binary has all symbols already. Might need to be OFF if your LLVM is static." ON)
+option(APPIMAGE_HACK "Links the clazy plugin to the clang tooling libs only. For some reason this is needed when building on our old CentOS 6.8 to create the AppImage." OFF)
 
 if (CLAZY_AST_MATCHERS_CRASH_WORKAROUND AND "${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
     message("Enabling AST Matchers workaround. Consider building with gcc instead. See bug #392223.")
@@ -52,7 +53,7 @@
   # disable trigger-happy warnings from Clang/LLVM headers
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4267 /wd4244 /wd4291 /wd4800 /wd4141 /wd4146 /wd4251")
 elseif(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
-  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -fno-common -Woverloaded-virtual -Wcast-qual -fno-strict-aliasing -pedantic -Wno-long-long -Wall -W -Wno-unused-parameter -Wwrite-strings -fno-exceptions -fno-rtti")
+  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++14 -fno-common -Woverloaded-virtual -Wcast-qual -fno-strict-aliasing -pedantic -Wno-long-long -Wall -W -Wno-unused-parameter -Wwrite-strings -fno-exceptions -fno-rtti")
 endif()
 
 set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -Wl,-flat_namespace -Wl,-undefined -Wl,suppress")
@@ -66,13 +67,12 @@
 message("Looking for std::regex support...")
 try_run(RUN_RESULT COMPILE_RESULT ${CMAKE_BINARY_DIR} ${CMAKE_CURRENT_LIST_DIR}/.cmake_has_regex_test.cpp)
 
-if(RUN_RESULT EQUAL 0)
-  set(HAS_STD_REGEX TRUE)
-else()
-  set(HAS_STD_REGEX FALSE)
-  add_definitions(-DNO_STD_REGEX)
-  message("old-style-connect check is disabled due to missing std::regex support")
-  message("Suppressions are disabled due to missing std::regex support")
+if(NOT RUN_RESULT EQUAL 0)
+  message("Using boost::regex instead of std::regex")
+  set(CLAZY_USES_BOOST_REGEX TRUE)
+  add_definitions(-DCLAZY_USES_BOOST_REGEX)
+  find_package(Boost REQUIRED COMPONENTS regex)
+  include_directories(${Boost_INCLUDE_DIRS})
 endif()
 
 include(ClazySources.cmake)
@@ -124,9 +124,17 @@
   if(WIN32)
     target_link_libraries(${name} version.lib)
   endif()
+  # clang >= 9.0 can provide a single shared library instead of split ones
+  if(CLANG_CLANG-CPP_LIB)
+    target_link_libraries(${name} clang-cpp)
+  else()
     target_link_libraries(${name} clangTooling)
     target_link_libraries(${name} clangToolingCore)
     target_link_libraries(${name} ${clang_tooling_refactoring_lib})
+  endif()
+  if (CLAZY_USES_BOOST_REGEX)
+    target_link_libraries(${name} ${Boost_LIBRARIES})
+  endif()
 endmacro()
 
 macro(add_clang_plugin name)
@@ -134,12 +142,24 @@
 
   add_library(${name} SHARED ${srcs})
 
+  if(${CMAKE_VERSION} VERSION_GREATER_EQUAL "3.16.0")
+      # 30% speedup
+      target_precompile_headers(${name} PRIVATE src/checkbase.h)
+  endif()
+
   if(SYMBOL_FILE)
     set_target_properties(${name} PROPERTIES LINK_FlAGS "-exported_symbols_list ${SYMBOL_FILE}")
   endif()
 
   if (LINK_CLAZY_TO_LLVM)
     link_to_llvm(${name} FALSE)
+  else()
+    if (APPIMAGE_HACK)
+        # Hack to build on old CentOS 6.8
+        target_link_libraries(${name} clangTooling)
+        target_link_libraries(${name} clangToolingCore)
+        target_link_libraries(${name} ${clang_tooling_refactoring_lib})
+    endif()
   endif()
 
   if(MSVC)
@@ -167,6 +187,14 @@
   set(SHARE_INSTALL_DIR ${CMAKE_INSTALL_DATAROOTDIR} CACHE STRING "Share directory name")
 
   if(NOT WIN32)
+    if(APPLE)
+      find_program(READLINK_CMD greadlink)
+    else()
+      find_program(READLINK_CMD readlink)
+    endif()
+    if(NOT READLINK_CMD)
+      message(FATAL_ERROR "Could not find a proper readlink.  On Mac OSX you should install coreutils using homebrew in order to use the GNU readlink")
+    endif()
     file(RELATIVE_PATH BIN_RELATIVE_LIBDIR "${CMAKE_INSTALL_FULL_BINDIR}" "${CMAKE_INSTALL_FULL_LIBDIR}")
     file(RELATIVE_PATH BIN_RELATIVE_SHAREDIR "${CMAKE_INSTALL_FULL_BINDIR}" "${CMAKE_INSTALL_FULL_DATAROOTDIR}")
     configure_file(${CMAKE_CURRENT_LIST_DIR}/clazy.cmake ${CMAKE_BINARY_DIR}/clazy @ONLY)
@@ -294,4 +322,3 @@
 to_raw_string_literal(${SUPPORTED_CHECKS_JSON_STR} SUPPORTED_CHECKS_JSON_STR)
 configure_file(checks.json.h.in checks.json.h)
 
-install(FILES org.kde.clazy.metainfo.xml DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/metainfo)

=== debian/changelog ===
clazy (1.7-2) unstable; urgency=medium

  * Exclude the inefficient-qlist check again, unfortunately on all the 32bit
    architectures: https://bugs.kde.org/423728.

 -- Pino Toscano <pino@debian.org>  Wed, 01 Jul 2020 10:44:27 +0200

clazy (1.7-1) unstable; urgency=medium

  [ Pino Toscano ]
  * New upstream release.
  * Update the patches:
    - select-clangpp.diff: refresh
  * Update lintian overrides.
  * Add Rules-Requires-Root: no.
  * Bump Standards-Version to 4.5.0, no changes required.
  * Run again the inefficient-qlist check on i386, as it was fixed upstream.
  * Change the python3 build dependency to python3:any, as Python is needed
    only as build tool.
  * Update copyright.

  [ Alexander Volkov ]
  * Don't install needless build dependencies when nocheck profile is enabled.

 -- Pino Toscano <pino@debian.org>  Wed, 01 Jul 2020 08:06:18 +0200

=== debian/control ===
--- 
+++ 
@@ -5,16 +5,17 @@
 Uploaders: Scarlett Clark <sgclark@kde.org>,
  Pino Toscano <pino@debian.org>
 Build-Depends: chrpath,
-               clang-9 (>= 1:5.0~),
-               clang-tools-9 (>= 1:5.0~),
+               clang (>= 1:5.0~),
+               clang-tools (>= 1:5.0~),
                cmake (>= 3.7~),
                debhelper-compat (= 12),
-               libclang-9-dev (>= 1:5.0~),
-               llvm-9-dev (>= 1:5.0~),
-               python3,
-               qtbase5-dev,
-               qtdeclarative5-dev,
-Standards-Version: 4.4.1
+               libclang-dev (>= 1:5.0~),
+               llvm-dev (>= 1:5.0~),
+               python3:any <!nocheck>,
+               qtbase5-dev <!nocheck>,
+               qtdeclarative5-dev <!nocheck>,
+Standards-Version: 4.5.0
+Rules-Requires-Root: no
 Homepage: https://www.kdab.com/clazy-video/
 Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/clazy.git
 Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/clazy

=== debian/rules ===
--- 
+++ 
@@ -3,9 +3,6 @@
 include /usr/share/dpkg/architecture.mk
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
-
-PATH := /usr/lib/llvm-9/bin:$(PATH)
-export PATH
 
 # LLVM 6.0 headers produce lots of class-memaccess warnings
 export DEB_CXXFLAGS_MAINT_APPEND = -Wno-class-memaccess
@@ -16,8 +13,8 @@
 endif
 
 # wrong size reported, although the test correctly identifies the issue
-# https://bugs.kde.org/show_bug.cgi?id=413169
-ifeq ($(DEB_HOST_ARCH),i386)
+# https://bugs.kde.org/show_bug.cgi?id=423728
+ifeq ($(DEB_HOST_ARCH_BITS),32)
 RUN_TESTS_ARGS += --exclude inefficient-qlist
 endif

=== debian/tests/control ===
Tests: run-tests
Depends: @, clang, clang-tools, python3, qtbase5-dev, qtdeclarative5-dev
Restrictions: rw-build-tree, allow-stderr
